IncludeScript(projectDir + "/_charlib/weapons.nut");
IncludeScript(projectDir + "/_charlib/weapon_models.nut");
IncludeScript(projectDir + "/_charlib/sound_bank.nut");

characterSettings <- {};
startingClass <- self.GetPlayerClass();
hasInitiated <- false;

function ConvertToCharacterInternal()
{
    local playerClass = safeget(characterSettings, "playerClass", null);
    if (playerClass)
        self.SetPlayerClass(playerClass);
    self.Regenerate(true);
}
OnSelfEvent("post_inventory_application", -19, function(params)
{
    if (hasInitiated && safeget(characterSettings, "cleanOnResupply", false))
    {
        ClearCustomCharacterInternal(true);
        return 117115;
    }
    if (safeget(characterSettings, "cleanOnClassChange", false) && self.GetPlayerClass() != startingClass)
    {
        ClearCustomCharacterInternal(true);
        return 117115;
    }
    hasInitiated <- true;

    local playerClass = safeget(characterSettings, "playerClass", null);
    if (playerClass)
    {
        self.RespawnFix();
        self.SetPlayerClass(playerClass);
        self.Regenerate(true);
    }

    if (safeget(characterSettings, "deleteItems", false))
        foreach(item in self.GetAttachments())
            DestroyIfValid(item);
});

OnSelfEvent("post_inventory_application_next", -18, function(params)
{
    self.SetCustomModelWithClassAnimations(safeget(characterSettings, "model", null));
    self.SetModelScale(safeget(characterSettings, "scale", 1), 0);

    if (safeget(characterSettings, "mute", false))
        self.AddCustomAttribute("voice pitch scale", 0, -1);

    FireCustomEvent("init_custom_character", params);
});

function ClearCustomCharacterInternal(respawn = false)
{
    try
    {
        FireCustomEvent("clear_custom_character", {
        	userid = self.GetUserID()
        });
    }
    catch(e) { }

    if (safeget(characterSettings, "cleanAttachmentsOnDeath", true))
        foreach(item in self.GetAttachments())
            if (IsValid(item) && item.GetClassname() != "tf_weapon_invis" && item.GetClassname() != "tf_weapon_medigun") //todo these weapons have something odd about them
                DestroyIfValid(item);

    if (!safeget(characterSettings, "model", null))
        self.SetCustomModelWithClassAnimations("");

    if (respawn == true)
        RunWithDelay(0.01, function(player) {
            if (IsValidPlayer(player))
            {
                player.ForceRegenerateAndRespawn();
                player.SetHealth(player.GetMaxHealth());
            }
        }, self, main_script);

    self.TerminateScriptScope();
}

OnSelfEvent("player_death", 0, function()
{
    RunWithDelay(0.1, function()
    {
        if (safeget(characterSettings, "cleanOnDeath", false))
            ClearCustomCharacterInternal();
    });
});

OnSelfEvent("player_disconnect", 0, ClearCustomCharacterInternal);
OnSelfEvent("player_team", 0, ClearCustomCharacterInternal);
OnGameEvent("scorestats_accumulated_update", 0, ClearCustomCharacterInternal);