local damageTables = player_collection(player_collection(0));
local teamSwitch = true;

OnGameEvent("OnTakeDamage", 100, function(victim, params)
{
    if (params.damage > 1000)
        params.damage = 1000;
});

OnGameEvent("player_hurt", 100, function(victim, params)
{
    local attacker = GetPlayerFromParams(params, "attacker");
    if (attacker && attacker.IsAlive())
        damageTables[victim.entindex()][attacker.entindex()] += params.damageamount;
    else
        attacker = victim;

    if (victim.GetHealth() <= 0)
    {
        local assister = GetAssister(victim, attacker);
        if (attacker != victim)
        {
            if (assister != victim)
                victim.AddCondEx(TF_COND_URINE, 0, assister);

            if (teamSwitch)
            {
                local victimTeam = victim.GetTeam();
                SetPropInt(victim, "m_iTeamNum", redTeamOnly ? 3 : 1);
                RunWithDelay(-1, function(victim)
                {
                    if (IsValidClient(victim))
                        SetPropInt(victim, "m_iTeamNum", victimTeam);
                }, victim, main_script)
            }
        }
        else if (assister != victim && teamSwitch)
        {
            victim.SetHealth(1100);
            local victimTeam = victim.GetTeam();
            RunWithDelay(-1, function(victim)
            {
                if (!IsValidClient(victim))
                    return;
                victim.SetHealth(1);
                victim.TakeDamageEx(
                    null,
                    assister,
                    null,
                    Vector(),
                    Vector(),
                    100,
                    0);
            }, victim, main_script)
        }
    }
});

function GetAssister(victim, attacker)
{
    attacker = attacker.entindex();
    local assister = victim.entindex();
    local damage = 20;
    foreach(iAssister, iDamage in damageTables[victim.entindex()])
    {
        if (iDamage > damage && iAssister != attacker)
        {
            assister = iAssister;
            damage = iDamage;
        }
    }
    return PlayerInstanceFromIndex(assister);
}

OnGameEvent("player_spawn", 0, function(player, params)
{
    damageTables[player.entindex()] = player_collection(0);
});

OnGameEvent("player_death", 0, function(player, params)
{
    for (local i = 0; i < MAX_PLAYERS; i++)
        damageTables[i][player.entindex()] = 0;
});

AddTimer(1, 0, function()
{
    for (local i =  0; i < MAX_PLAYERS; i++)
        for (local j =  0; j < MAX_PLAYERS; j++)
            damageTables[i][j] *= 0.7;
});