//===========================================================
//Make projectiles instantly collide with other players
//===========================================================

lastProjectileTeam <- TF_TEAM_RED;
AddTimer(-1, 0, function ()
{
    lastProjectileTeam = lastProjectileTeam == TF_TEAM_RED ? TF_TEAM_BLUE : TF_TEAM_RED;
    for (local projectile; projectile = Entities.FindByClassname(projectile, "tf_projectile*");)
    {
        SetPropBool(projectile, "m_bForcePurgeFixedupStrings", true);
        projectile.SetTeam(redTeamOnly ? 3 : lastProjectileTeam);
    }
});

//===========================================================
//Cancel out Medic's self-heal
//===========================================================

OnGameEvent("player_healed", function(params)
{
    if (params.patient == params.healer && params.amount < 10)
    {
        local player = GetPlayerFromUserID(params.patient);
        if (player && player.GetPlayerClass() == TF_CLASS_MEDIC)
            player.SetHealth(player.GetHealth() - params.amount);
    }
});

//===========================================================
//Avoid spawning right next to others
//===========================================================

local info_player_teamspawns = [];

for (local spawn = null; spawn = Entities.FindByClassname(spawn, "info_player_teamspawn");)
{
    SetPropBool(spawn, "m_bForcePurgeFixedupStrings", true);
    info_player_teamspawns.push(spawn);
}

OnGameEvent("player_spawn_post", -101, function(player, params)
{
    local target = TryFindFreeSpawn(player, 500);
    if (!target && player.GetTeam() == TF_TEAM_BLUE)
        target = RandomElement(info_player_teamspawns);
    if (target)
        player.Teleport(true, target.GetOrigin(), true, target.GetAbsAngles(), true, Vector());
});

function TryFindFreeSpawn(player, radius)
{
    local myPos = player.GetOrigin();
    local players = GetAllPlayers();
    foreach(spawnEnt in ShuffleArray(info_player_teamspawns))
    {
        local flag = true;
        local spawnEntPos = spawnEnt.GetOrigin();
        foreach (otherPlayer in players)
        {
            if (player != otherPlayer && (otherPlayer.GetOrigin() - spawnEntPos).Length() < radius)
            {
                flag = false;
                break;
            }
        }
        if (flag)
            return spawnEnt;
    }
    return null;
}

//===========================================================
//Music
//===========================================================

PrecacheScriptSound("MapMusic");

foreach(player in GetAllClients())
    EmitSoundEx({
        sound_name = "MapMusic",
        filter_type = RECIPIENT_FILTER_SINGLE_PLAYER,
        channel = 415,
        volume = 0.6,
        entity = player
    });

OnGameEvent("player_team", 0, function(player, params)
{
    if (params.oldteam < 2)
        EmitSoundEx({
        	sound_name = "MapMusic",
    	    filter_type = RECIPIENT_FILTER_SINGLE_PLAYER,
            channel = 415,
            volume = 0.6,
            entity = player
        });
});

//===========================================================
//Music
//===========================================================

RunWithDelay(8, function()
{
    foreach(player in GetPlayers())
        BuildSound("battle_cry").Scope(player).Voice().SinglePlayer().Play();
});