local canBattleCryTS = Time() + 8;

AddTimer(-1, function() {
    for (local scene = null; scene = Entities.FindByClassname(scene, "instanced_scripted_scene");)
    {
        SetPropBool(scene, "m_bForcePurgeFixedupStrings", true);
        scene.KeyValueFromString("classname", "invalid");
        local player = NetProps.GetPropEntity(scene, "m_hOwner");
        if (IsValidPlayer(player))
            PlayVCDReplacement(player, scene);
    }
});

function PlayVCDReplacement(player, scene)
{
    local path = NetProps.GetPropString(scene, "m_szInstanceFilename");
    if (!path)
        return;
    local splits = split(path, "/");
    if (splits.len() == 1)
        splits = split(path, "\\");
    local str = splits[splits.len() - 1];
    local vcdIndex = str.slice(0, str.len() - 4);
    local soundName = safeget(VCDTable, vcdIndex, null);
    if (soundName == "battle_cry" && Time() < canBattleCryTS)
        return;
    if (startswith(soundName, "pain") && RandomInt(0, 2))
        return;
    BuildSound(soundName).Scope(player).Voice().Play();
}

OnGameEvent("player_domination", function(params)
{
    local player = GetPlayerFromParams(params, "dominator");
    if (player && !RandomInt(0, 2))
        BuildSound("domination").Delay(3).Scope(player).Voice().Play();
});

OnGameEvent("player_death", function(params)
{
    if ((params.damagebits & 128) && !RandomInt(0, 4))
    {
        local attacker = GetPlayerFromParams(params, "attacker");
        if (attacker)
            BuildSound("melee_kill").Delay(2).Scope(attacker).Voice().Play();
    }
});

::VCDTable <- {
    //Demoman
    "1358":		"battle_cry",
    "1369":		"battle_cry",
    "876":		"battle_cry",
    "877":		"battle_cry",
    "878":		"battle_cry",
    "879":		"battle_cry",
    "880":		"battle_cry",
    "938":		"jeers",
    "939":		"jeers",
    "940":		"jeers",
    "941":		"jeers",
    "942":		"jeers",
    "944":		"jeers",
    "945":		"jeers",
    "947":		"jeers",
    "948":		"jeers",
    "949":		"jeers",
    "946":		"jeers",
    "947":		"jeers",
    "969":		"negative",
    "971":		"negative",
    "910":		"laugh_evil",
    "950":		"laugh_evil",
    "1379":		"laugh_evil",
    "884":		"cheers",
    "887":		"cheers",
    "952":		"laugh_happy",
    "955":		"laugh_short",
    "989":		"positive",
    "991":		"positive",
    "992":		"positive",
    "993":		"positive",
    "886":		"cheers",
    "910":		"laugh_evil",
    "950":		"laugh_evil",
    "1379":		"laugh_evil",
    "1384":		"laugh_evil",
    "1385":		"laugh_evil",
    "951":		"laugh_happy",
    "953":		"laugh_long",
    "954":		"laugh_long",
    "956":		"laugh_short",
    "1383":		"laugh_short",
    "914":		"good_job",
    "990":		"positive",
    "983":		"pain_severe",
    "984":		"pain_severe",
    "985":		"pain_severe",
    "1396":		"pain_severe",
    "872":		"on_fire",
    "874":		"on_fire",
    "873":		"on_fire",
    "986":		"pain_sharp",
    "987":		"pain_sharp",
    "988":		"pain_sharp",
    "1392":		"pain_sharp",
    "1393":		"pain_sharp",
    "1394":		"pain_sharp",
    "1395":		"pain_sharp",
    "1927":		"pain_sharp",
    "1038":		"yes",
    "879":		"battle_cry",
    "1369":		"battle_cry",
    "938":		"jeers",
    "939":		"jeers",
    "911":		"go",
    "912":		"go",
    "913":		"go",
    "917":		"head_left",
    "918":		"head_left",
    "919":		"head_left",
    "920":		"head_right",
    "921":		"head_right",
    "922":		"head_right",
    "923":		"help",
    "924":		"help",
    "925":		"help",
    "957":		"medic",
    "958":		"medic",
    "959":		"medic",
    "960":		"move_up",
    "961":		"move_up",
    "962":		"move_up",
    "977":		"no",
    "978":		"no",
    "979":		"no",
    "1030":		"thanks",
    "1031":		"thanks",
    "1037":		"yes",
    "1038":		"yes",
    "1039":		"yes",
    "964":		"need_dispenser",
    "932":		"incoming",
    "933":		"incoming",
    "934":		"incoming",
    "966":		"need_sentry",
    "1358":		"battle_cry",
    "1369":		"battle_cry",
    "876":		"battle_cry",
    "877":		"battle_cry",
    "878":		"battle_cry",
    "879":		"battle_cry",
    "880":		"battle_cry",
    "881":		"cheers",
    "883":		"cheers",
    "884":		"cheers",
    "1359":		"cheers",
    "886":		"cheers",
    "887":		"cheers",
    "882":		"cheers",
    "885":		"cheers",
    "914":		"good_job",
    "915":		"good_job",
    "938":		"jeers",
    "939":		"jeers",
    "940":		"jeers",
    "941":		"jeers",
    "942":		"jeers",
    "944":		"jeers",
    "945":		"jeers",
    "947":		"jeers",
    "948":		"jeers",
    "949":		"jeers",
    "946":		"jeers",
    "973":		"negative",
    "1360":		"negative",
    "969":		"negative",
    "970":		"negative",
    "971":		"negative",
    "972":		"negative",
    "973":		"negative",
    "1360":		"negative",
    "969":		"negative",
    "970":		"negative",
    "971":		"negative",
    "972":		"negative",
    "974":		"nice_shot",
    "975":		"nice_shot",
    "976":		"nice_shot",
    "989":		"positive",
    "990":		"positive",
    "991":		"positive",
    "992":		"positive",
    "993":		"positive",
    "1380":		"laugh_short",
    "1382":		"laugh_short",
    "1386":		"laugh_short",
    //Engineer
    "31":		"battle_cry",
    "33":		"battle_cry",
    "34":		"battle_cry",
    "35":		"battle_cry",
    "36":		"battle_cry",
    "1329":		"battle_cry",
    "94":		"jeers",
    "95":		"jeers",
    "96":		"jeers",
    "98":		"jeers",
    "36":		"battle_cry",
    "1330":		"cheers",
    "42":		"cheers",
    "43":		"cheers",
    "41":		"cheers",
    "1329":		"battle_cry",
    "40":		"cheers",
    "39":		"cheers",
    "44":		"cheers",
    "98":		"jeers",
    "100":		"laugh_evil",
    "1331":		"laugh_evil",
    "1335":		"laugh_evil",
    "1336":		"laugh_evil",
    "101":		"laugh_happy",
    "1334":		"laugh_happy",
    "102":		"laugh_happy",
    "103":		"laugh_long",
    "133":		"pain_severe",
    "134":		"pain_severe",
    "135":		"pain_severe",
    "1254":		"pain_severe",
    "1255":		"pain_severe",
    "1256":		"pain_severe",
    "1257":		"pain_severe",
    "28":		"on_fire",
    "30":		"on_fire",
    "29":		"on_fire",
    "136":		"pain_sharp",
    "137":		"pain_sharp",
    "138":		"pain_sharp",
    "1249":		"pain_sharp",
    "1250":		"pain_sharp",
    "1251":		"pain_sharp",
    "1252":		"pain_sharp",
    "1253":		"pain_sharp",
    "1931":		"pain_sharp",
    "35":		"battle_cry",
    "188":		"yes",
    "94":		"jeers",
    "69":		"go",
    "68":		"go",
    "67":		"go",
    "73":		"head_left",
    "75":		"head_left",
    "76":		"head_right",
    "77":		"head_right",
    "78":		"head_right",
    "79":		"help",
    "80":		"help",
    "81":		"help",
    "109":		"medic",
    "107":		"medic",
    "108":		"medic",
    "111":		"move_up",
    "127":		"no",
    "128":		"no",
    "129":		"no",
    "180":		"thanks",
    "187":		"yes",
    "188":		"yes",
    "189":		"yes",
    "113":		"need_dispenser",
    "88":		"incoming",
    "89":		"incoming",
    "90":		"incoming",
    "115":		"need_sentry",
    "31":		"battle_cry",
    "33":		"battle_cry",
    "34":		"battle_cry",
    "35":		"battle_cry",
    "36":		"battle_cry",
    "1329":		"battle_cry",
    "40":		"cheers",
    "1330":		"cheers",
    "42":		"cheers",
    "43":		"cheers",
    "41":		"cheers",
    "39":		"cheers",
    "44":		"cheers",
    "70":		"good_job",
    "72":		"good_job",
    "71":		"good_job",
    "94":		"jeers",
    "95":		"jeers",
    "96":		"jeers",
    "98":		"jeers",
    "1327":		"negative",
    "1328":		"negative",
    "119":		"negative",
    "120":		"negative",
    "122":		"negative",
    "121":		"negative",
    "123":		"negative",
    "1339":		"negative",
    "1340":		"negative",
    "1341":		"negative",
    "1342":		"negative",
    "1343":		"negative",
    "1327":		"negative",
    "1328":		"negative",
    "119":		"negative",
    "120":		"negative",
    "122":		"negative",
    "121":		"negative",
    "123":		"negative",
    "1339":		"negative",
    "1340":		"negative",
    "1341":		"negative",
    "1342":		"negative",
    "1343":		"negative",
    "125":		"nice_shot",
    "126":		"nice_shot",
    "124":		"nice_shot",
    "139":		"positive",
    //Heavy
    "205":		"battle_cry",
    "206":		"battle_cry",
    "207":		"battle_cry",
    "208":		"battle_cry",
    "209":		"battle_cry",
    "210":		"battle_cry",
    "258":		"jeers",
    "259":		"jeers",
    "260":		"jeers",
    "261":		"jeers",
    "262":		"jeers",
    "263":		"jeers",
    "264":		"jeers",
    "265":		"jeers",
    "266":		"jeers",
    "1273":		"laugh_short",
    "272":		"laugh_short",
    "273":		"laugh_short",
    "1267":		"negative",
    "259":		"jeers",
    "1265":		"good_job",
    "289":		"nice_shot",
    "306":		"positive",
    "235":		"good_job",
    "263":		"jeers",
    "267":		"laugh_evil",
    "268":		"laugh_happy",
    "269":		"laugh_happy",
    "1268":		"laugh_happy",
    "1269":		"laugh_happy",
    "1272":		"laugh_happy",
    "270":		"laugh_long",
    "271":		"laugh_long",
    "2067":		"laugh_long",
    "2265":		"laugh_long",
    "2266":		"laugh_long",
    "303":		"positive",
    "304":		"positive",
    "213":		"cheers",
    "216":		"cheers",
    "305":		"positive",
    "2264":		"laugh_long",
    "297":		"pain_severe",
    "298":		"pain_severe",
    "299":		"pain_severe",
    "202":		"on_fire",
    "203":		"on_fire",
    "1400":		"on_fire",
    "204":		"on_fire",
    "1399":		"on_fire",
    "300":		"pain_sharp",
    "301":		"pain_sharp",
    "302":		"pain_sharp",
    "1390":		"pain_sharp",
    "1391":		"pain_sharp",
    "1925":		"pain_sharp",
    "205":		"battle_cry",
    "350":		"yes",
    "351":		"yes",
    "1975":		"melee_dare",
    "1977":		"melee_dare",
    "2090":		"melee_dare",
    "2091":		"melee_dare",
    "2119":		"melee_dare",
    "2205":		"melee_dare",
    "2258":		"melee_dare",
    "258":		"jeers",
    "231":		"go",
    "232":		"go",
    "233":		"go",
    "237":		"head_left",
    "238":		"head_left",
    "239":		"head_left",
    "240":		"head_right",
    "241":		"head_right",
    "242":		"head_right",
    "243":		"help",
    "244":		"help",
    "245":		"help",
    "274":		"medic",
    "275":		"medic",
    "276":		"medic",
    "277":		"move_up",
    "278":		"move_up",
    "279":		"move_up",
    "291":		"no",
    "292":		"no",
    "293":		"no",
    "342":		"thanks",
    "343":		"thanks",
    "1278":		"thanks",
    "350":		"yes",
    "351":		"yes",
    "352":		"yes",
    "280":		"need_dispenser",
    "252":		"incoming",
    "253":		"incoming",
    "254":		"incoming",
    "281":		"need_sentry",
    "205":		"battle_cry",
    "206":		"battle_cry",
    "207":		"battle_cry",
    "208":		"battle_cry",
    "209":		"battle_cry",
    "210":		"battle_cry",
    "1975":		"melee_dare",
    "1976":		"melee_dare",
    "1977":		"melee_dare",
    "2087":		"melee_dare",
    "2090":		"melee_dare",
    "2091":		"melee_dare",
    "2092":		"melee_dare",
    "2093":		"melee_dare",
    "2106":		"melee_dare",
    "2107":		"melee_dare",
    "2119":		"melee_dare",
    "2205":		"melee_dare",
    "2258":		"melee_dare",
    "211":		"cheers",
    "212":		"cheers",
    "213":		"cheers",
    "214":		"cheers",
    "215":		"cheers",
    "216":		"cheers",
    "217":		"cheers",
    "1263":		"cheers",
    "234":		"good_job",
    "235":		"good_job",
    "236":		"good_job",
    "1265":		"good_job",
    "258":		"jeers",
    "259":		"jeers",
    "260":		"jeers",
    "261":		"jeers",
    "262":		"jeers",
    "263":		"jeers",
    "264":		"jeers",
    "265":		"jeers",
    "266":		"jeers",
    "1267":		"negative",
    "283":		"negative",
    "284":		"negative",
    "285":		"negative",
    "286":		"negative",
    "287":		"negative",
    "1267":		"negative",
    "283":		"negative",
    "284":		"negative",
    "285":		"negative",
    "286":		"negative",
    "287":		"negative",
    "288":		"nice_shot",
    "289":		"nice_shot",
    "290":		"nice_shot",
    "303":		"positive",
    "304":		"positive",
    "305":		"positive",
    "306":		"positive",
    "307":		"positive",
    "1270":		"laugh_evil",
    "1271":		"laugh_evil",
    "1274":		"laugh_evil",
    "1273":		"laugh_short",
    //Medic
    "537":		"battle_cry",
    "539":		"battle_cry",
    "540":		"battle_cry",
    "541":		"battle_cry",
    "542":		"battle_cry",
    "543":		"battle_cry",
    "592":		"jeers",
    "593":		"jeers",
    "594":		"jeers",
    "595":		"jeers",
    "596":		"jeers",
    "597":		"jeers",
    "598":		"jeers",
    "599":		"jeers",
    "600":		"jeers",
    "601":		"jeers",
    "603":		"jeers",
    "602":		"jeers",
    "622":		"negative",
    "623":		"negative",
    "1227":		"laugh_evil",
    "1232":		"laugh_evil",
    "605":		"laugh_happy",
    "606":		"laugh_happy",
    "1229":		"laugh_happy",
    "607":		"laugh_long",
    "608":		"laugh_long",
    "1230":		"laugh_short",
    "545":		"cheers",
    "551":		"cheers",
    "552":		"cheers",
    "641":		"positive",
    "569":		"good_job",
    "620":		"negative",
    "1233":		"negative",
    "1234":		"negative",
    "633":		"pain_severe",
    "634":		"pain_severe",
    "635":		"pain_severe",
    "1243":		"pain_severe",
    "534":		"on_fire",
    "535":		"on_fire",
    "536":		"on_fire",
    "1401":		"on_fire",
    "1402":		"on_fire",
    "636":		"pain_sharp",
    "637":		"pain_sharp",
    "638":		"pain_sharp",
    "1244":		"pain_sharp",
    "1245":		"pain_sharp",
    "1246":		"pain_sharp",
    "1247":		"pain_sharp",
    "1248":		"pain_sharp",
    "1924":		"pain_sharp",
    "541":		"battle_cry",
    "640":		"positive",
    "689":		"yes",
    "690":		"yes",
    "597":		"jeers",
    "596":		"jeers",
    "565":		"go",
    "566":		"go",
    "567":		"go",
    "1226":		"go",
    "571":		"head_left",
    "572":		"head_left",
    "573":		"head_left",
    "574":		"head_right",
    "575":		"head_right",
    "576":		"head_right",
    "577":		"help",
    "578":		"help",
    "579":		"help",
    "611":		"medic",
    "612":		"medic",
    "613":		"medic",
    "614":		"move_up",
    "615":		"move_up",
    "627":		"no",
    "628":		"no",
    "629":		"no",
    "681":		"thanks",
    "682":		"thanks",
    "689":		"yes",
    "690":		"yes",
    "691":		"yes",
    "616":		"need_dispenser",
    "586":		"incoming",
    "587":		"incoming",
    "588":		"incoming",
    "617":		"need_sentry",
    "537":		"battle_cry",
    "539":		"battle_cry",
    "540":		"battle_cry",
    "541":		"battle_cry",
    "542":		"battle_cry",
    "543":		"battle_cry",
    "544":		"cheers",
    "545":		"cheers",
    "548":		"cheers",
    "550":		"cheers",
    "551":		"cheers",
    "552":		"cheers",
    "568":		"good_job",
    "569":		"good_job",
    "570":		"good_job",
    "592":		"jeers",
    "593":		"jeers",
    "594":		"jeers",
    "595":		"jeers",
    "596":		"jeers",
    "597":		"jeers",
    "598":		"jeers",
    "599":		"jeers",
    "600":		"jeers",
    "601":		"jeers",
    "603":		"jeers",
    "602":		"jeers",
    "619":		"negative",
    "620":		"negative",
    "621":		"negative",
    "622":		"negative",
    "623":		"negative",
    "1233":		"negative",
    "1234":		"negative",
    "619":		"negative",
    "620":		"negative",
    "621":		"negative",
    "622":		"negative",
    "623":		"negative",
    "1233":		"negative",
    "1234":		"negative",
    "624":		"nice_shot",
    "625":		"nice_shot",
    "639":		"positive",
    "640":		"positive",
    "641":		"positive",
    "1235":		"positive",
    "1236":		"positive",
    "604":		"laugh_evil",
    "1228":		"laugh_evil",
    "1231":		"laugh_evil",
    "609":		"laugh_short",
    "610":		"laugh_short",
    //Pyro
    "1482":		"laugh_evil",
    "1595":		"laugh_evil",
    "1454":		"good_job",
    "1510":		"positive",
    "1483":		"laugh_happy",
    "1418":		"battle_cry",
    "1419":		"battle_cry",
    "1476":		"jeers",
    "1477":		"jeers",
    "1416":		"on_fire",
    "1485":		"laugh_long",
    "1421":		"cheers",
    "1450":		"laugh_evil",
    "1482":		"laugh_evil",
    "1483":		"laugh_happy",
    "1485":		"laugh_long",
    "1418":		"battle_cry",
    "1581":		"pain_severe",
    "1582":		"pain_severe",
    "1583":		"pain_severe",
    "1591":		"pain_severe",
    "1592":		"pain_severe",
    "1593":		"pain_severe",
    "1415":		"on_fire",
    "1416":		"on_fire",
    "1584":		"pain_sharp",
    "1585":		"pain_sharp",
    "1586":		"pain_sharp",
    "1587":		"pain_sharp",
    "1588":		"pain_sharp",
    "1589":		"pain_sharp",
    "1590":		"pain_sharp",
    "1930":		"pain_sharp",
    "1415":		"on_fire",
    "1550":		"thanks",
    "1499":		"negative",
    "1419":		"battle_cry",
    "1451":		"go",
    "1457":		"head_left",
    "1460":		"head_right",
    "1463":		"help",
    "1489":		"medic",
    "1492":		"move_up",
    "1507":		"no",
    "1550":		"thanks",
    "1558":		"yes",
    "1493":		"need_dispenser",
    "1472":		"incoming",
    "1495":		"need_sentry",
    "1418":		"battle_cry",
    "1419":		"battle_cry",
    "1482":		"laugh_evil",
    "1421":		"cheers",
    "1454":		"good_job",
    "1476":		"jeers",
    "1477":		"jeers",
    "1499":		"negative",
    "1499":		"negative",
    "1504":		"nice_shot",
    "1510":		"positive",
    "1563":		"laugh_evil",
    "1595":		"laugh_evil",
    "1487":		"laugh_short",
    //Scout
    "367":		"battle_cry",
    "369":		"battle_cry",
    "370":		"battle_cry",
    "371":		"battle_cry",
    "368":		"battle_cry",
    "419":		"jeers",
    "420":		"jeers",
    "421":		"jeers",
    "422":		"jeers",
    "423":		"jeers",
    "424":		"jeers",
    "425":		"jeers",
    "426":		"jeers",
    "427":		"jeers",
    "428":		"jeers",
    "430":		"jeers",
    "396":		"good_job",
    "1297":		"laugh_evil",
    "432":		"laugh_happy",
    "433":		"laugh_happy",
    "1295":		"laugh_happy",
    "1296":		"laugh_happy",
    "434":		"laugh_long",
    "435":		"laugh_long",
    "377":		"cheers",
    "433":		"laugh_happy",
    "435":		"laugh_long",
    "426":		"jeers",
    "450":		"negative",
    "451":		"negative",
    "396":		"good_job",
    "372":		"cheers",
    "373":		"cheers",
    "454":		"nice_shot",
    "374":		"cheers",
    "453":		"nice_shot",
    "461":		"pain_severe",
    "462":		"pain_severe",
    "463":		"pain_severe",
    "1361":		"pain_severe",
    "1362":		"pain_severe",
    "1363":		"pain_severe",
    "365":		"on_fire",
    "366":		"on_fire",
    "464":		"pain_sharp",
    "465":		"pain_sharp",
    "466":		"pain_sharp",
    "1364":		"pain_sharp",
    "1365":		"pain_sharp",
    "1366":		"pain_sharp",
    "1367":		"pain_sharp",
    "1368":		"pain_sharp",
    "1932":		"pain_sharp",
    "377":		"cheers",
    "516":		"yes",
    "2579":		"melee_dare",
    "2580":		"melee_dare",
    "2582":		"melee_dare",
    "2583":		"melee_dare",
    "2581":		"melee_dare",
    "419":		"jeers",
    "421":		"jeers",
    "393":		"go",
    "1286":		"go",
    "392":		"go",
    "394":		"go",
    "398":		"head_left",
    "399":		"head_left",
    "400":		"head_left",
    "401":		"head_right",
    "402":		"head_right",
    "403":		"head_right",
    "404":		"help",
    "1290":		"help",
    "405":		"help",
    "406":		"help",
    "438":		"medic",
    "439":		"medic",
    "440":		"medic",
    "441":		"move_up",
    "442":		"move_up",
    "443":		"move_up",
    "455":		"no",
    "456":		"no",
    "457":		"no",
    "508":		"thanks",
    "509":		"thanks",
    "516":		"yes",
    "517":		"yes",
    "518":		"yes",
    "444":		"need_dispenser",
    "413":		"incoming",
    "414":		"incoming",
    "415":		"incoming",
    "445":		"need_sentry",
    "367":		"battle_cry",
    "369":		"battle_cry",
    "370":		"battle_cry",
    "371":		"battle_cry",
    "368":		"battle_cry",
    "2584":		"melee_dare",
    "2579":		"melee_dare",
    "2580":		"melee_dare",
    "2582":		"melee_dare",
    "2583":		"melee_dare",
    "2581":		"melee_dare",
    "372":		"cheers",
    "374":		"cheers",
    "375":		"cheers",
    "377":		"cheers",
    "376":		"cheers",
    "373":		"cheers",
    "395":		"good_job",
    "396":		"good_job",
    "397":		"good_job",
    "1288":		"good_job",
    "419":		"jeers",
    "420":		"jeers",
    "421":		"jeers",
    "422":		"jeers",
    "423":		"jeers",
    "424":		"jeers",
    "425":		"jeers",
    "426":		"jeers",
    "427":		"jeers",
    "428":		"jeers",
    "430":		"jeers",
    "451":		"negative",
    "447":		"negative",
    "449":		"negative",
    "450":		"negative",
    "448":		"negative",
    "451":		"negative",
    "447":		"negative",
    "449":		"negative",
    "450":		"negative",
    "448":		"negative",
    "452":		"nice_shot",
    "453":		"nice_shot",
    "454":		"nice_shot",
    "1302":		"positive",
    "467":		"positive",
    "469":		"positive",
    "470":		"positive",
    "471":		"positive",
    "1298":		"laugh_evil",
    "436":		"laugh_short",
    "437":		"laugh_short",
    "1299":		"laugh_short",
    "1300":		"laugh_short",
    "1301":		"laugh_short",
    //Sniper
    "1612":		"battle_cry",
    "1613":		"battle_cry",
    "1614":		"battle_cry",
    "1615":		"battle_cry",
    "1616":		"battle_cry",
    "1617":		"battle_cry",
    "1662":		"jeers",
    "1663":		"jeers",
    "1664":		"jeers",
    "1665":		"jeers",
    "1666":		"jeers",
    "1667":		"jeers",
    "1668":		"jeers",
    "1669":		"jeers",
    "1670":		"laugh_evil",
    "1671":		"laugh_evil",
    "1672":		"laugh_happy",
    "1673":		"laugh_happy",
    "1674":		"laugh_long",
    "1675":		"laugh_long",
    "1675":		"laugh_long",
    "1670":		"laugh_evil",
    "1671":		"laugh_evil",
    "1674":		"laugh_long",
    "1688":		"negative",
    "1689":		"negative",
    "1780":		"negative",
    "1690":		"negative",
    "1778":		"negative",
    "1614":		"battle_cry",
    "1619":		"cheers",
    "1620":		"cheers",
    "1710":		"positive",
    "1622":		"cheers",
    "1641":		"good_job",
    "1708":		"positive",
    "1709":		"positive",
    "1700":		"pain_severe",
    "1701":		"pain_severe",
    "1702":		"pain_severe",
    "1838":		"pain_severe",
    "1609":		"on_fire",
    "1610":		"on_fire",
    "1611":		"on_fire",
    "1705":		"pain_sharp",
    "1704":		"pain_sharp",
    "1703":		"pain_sharp",
    "1837":		"pain_sharp",
    "1929":		"pain_sharp",
    "1613":		"battle_cry",
    "1614":		"battle_cry",
    "2321":		"melee_dare",
    "2389":		"melee_dare",
    "1768":		"yes",
    "1769":		"yes",
    "2320":		"melee_dare",
    "2369":		"melee_dare",
    "2372":		"melee_dare",
    "2373":		"melee_dare",
    "1663":		"jeers",
    "1686":		"negative",
    "1687":		"negative",
    "1640":		"go",
    "1639":		"go",
    "1638":		"go",
    "1644":		"head_left",
    "1645":		"head_left",
    "1646":		"head_left",
    "1647":		"head_right",
    "1648":		"head_right",
    "1649":		"head_right",
    "1650":		"help",
    "1651":		"help",
    "1652":		"help",
    "1678":		"medic",
    "1679":		"medic",
    "1681":		"move_up",
    "1682":		"move_up",
    "1694":		"no",
    "1695":		"no",
    "1696":		"no",
    "1782":		"no",
    "1760":		"thanks",
    "1836":		"thanks",
    "1767":		"yes",
    "1768":		"yes",
    "1769":		"yes",
    "1683":		"need_dispenser",
    "1659":		"incoming",
    "1660":		"incoming",
    "1661":		"incoming",
    "1773":		"incoming",
    "1684":		"need_sentry",
    "1612":		"battle_cry",
    "1613":		"battle_cry",
    "1614":		"battle_cry",
    "1615":		"battle_cry",
    "1616":		"battle_cry",
    "1617":		"battle_cry",
    "2319":		"melee_dare",
    "2320":		"melee_dare",
    "2321":		"melee_dare",
    "2369":		"melee_dare",
    "2372":		"melee_dare",
    "2373":		"melee_dare",
    "2374":		"melee_dare",
    "2388":		"melee_dare",
    "2389":		"melee_dare",
    "1618":		"cheers",
    "1619":		"cheers",
    "1620":		"cheers",
    "1621":		"cheers",
    "1622":		"cheers",
    "1623":		"cheers",
    "1624":		"cheers",
    "1625":		"cheers",
    "1641":		"good_job",
    "1642":		"good_job",
    "1643":		"good_job",
    "1662":		"jeers",
    "1663":		"jeers",
    "1664":		"jeers",
    "1665":		"jeers",
    "1666":		"jeers",
    "1667":		"jeers",
    "1668":		"jeers",
    "1669":		"jeers",
    "1686":		"negative",
    "1687":		"negative",
    "1688":		"negative",
    "1689":		"negative",
    "1690":		"negative",
    "1778":		"negative",
    "1779":		"negative",
    "1780":		"negative",
    "1781":		"negative",
    "1686":		"negative",
    "1687":		"negative",
    "1688":		"negative",
    "1689":		"negative",
    "1690":		"negative",
    "1778":		"negative",
    "1779":		"negative",
    "1780":		"negative",
    "1781":		"negative",
    "1691":		"nice_shot",
    "1692":		"nice_shot",
    "1693":		"nice_shot",
    "1706":		"positive",
    "1707":		"positive",
    "1708":		"positive",
    "1709":		"positive",
    "1710":		"positive",
    "1783":		"positive",
    "1784":		"positive",
    "1785":		"positive",
    "1786":		"positive",
    "1787":		"positive",
    "1774":		"laugh_evil",
    "1676":		"laugh_short",
    "1677":		"laugh_short",
    "1775":		"laugh_short",
    "1776":		"laugh_short",
    "1777":		"laugh_short",
    //Soldiers
    "1135":		"laugh_long",
    "1347":		"laugh_happy",
    "1055":		"battle_cry",
    "1057":		"battle_cry",
    "1058":		"battle_cry",
    "1059":		"battle_cry",
    "1056":		"battle_cry",
    "1060":		"battle_cry",
    "1120":		"jeers",
    "1121":		"jeers",
    "1122":		"jeers",
    "1123":		"jeers",
    "1124":		"jeers",
    "1125":		"jeers",
    "1126":		"jeers",
    "1127":		"jeers",
    "1128":		"jeers",
    "1129":		"jeers",
    "1130":		"jeers",
    "1131":		"jeers",
    "1155":		"negative",
    "1353":		"negative",
    "1152":		"negative",
    "1064":		"cheers",
    "1062":		"cheers",
    "1063":		"cheers",
    "1132":		"laugh_evil",
    "1346":		"laugh_evil",
    "1348":		"laugh_evil",
    "1133":		"laugh_happy",
    "1134":		"laugh_happy",
    "1347":		"laugh_happy",
    "1135":		"laugh_long",
    "1349":		"laugh_long",
    "1060":		"battle_cry",
    "1065":		"cheers",
    "1096":		"good_job",
    "1055":		"battle_cry",
    "1345":		"positive",
    "1172":		"positive",
    "1175":		"positive",
    "1165":		"pain_severe",
    "1166":		"pain_severe",
    "1167":		"pain_severe",
    "1371":		"pain_severe",
    "1372":		"pain_severe",
    "1373":		"pain_severe",
    "1052":		"on_fire",
    "1053":		"on_fire",
    "1054":		"on_fire",
    "1168":		"pain_sharp",
    "1169":		"pain_sharp",
    "1170":		"pain_sharp",
    "1374":		"pain_sharp",
    "1375":		"pain_sharp",
    "1376":		"pain_sharp",
    "1377":		"pain_sharp",
    "1378":		"pain_sharp",
    "1926":		"pain_sharp",
    "1062":		"cheers",
    "1172":		"positive",
    "1175":		"positive",
    "1174":		"positive",
    "1221":		"yes",
    "1094":		"go",
    "1120":		"jeers",
    "1092":		"go",
    "1093":		"go",
    "1094":		"go",
    "1098":		"head_left",
    "1100":		"head_left",
    "1099":		"head_left",
    "1103":		"head_right",
    "1101":		"head_right",
    "1102":		"head_right",
    "1104":		"help",
    "1105":		"help",
    "1106":		"help",
    "1139":		"medic",
    "1140":		"medic",
    "1141":		"medic",
    "1142":		"move_up",
    "1143":		"move_up",
    "1144":		"move_up",
    "1159":		"no",
    "1161":		"no",
    "1160":		"no",
    "1211":		"thanks",
    "1212":		"thanks",
    "1350":		"yes",
    "1220":		"yes",
    "1221":		"yes",
    "1219":		"yes",
    "1146":		"need_dispenser",
    "1114":		"incoming",
    "1148":		"need_sentry",
    "1055":		"battle_cry",
    "1057":		"battle_cry",
    "1058":		"battle_cry",
    "1059":		"battle_cry",
    "1056":		"battle_cry",
    "1060":		"battle_cry",
    "1065":		"cheers",
    "1068":		"cheers",
    "1066":		"cheers",
    "1064":		"cheers",
    "1062":		"cheers",
    "1063":		"cheers",
    "1095":		"good_job",
    "1096":		"good_job",
    "1097":		"good_job",
    "1120":		"jeers",
    "1121":		"jeers",
    "1122":		"jeers",
    "1123":		"jeers",
    "1124":		"jeers",
    "1125":		"jeers",
    "1126":		"jeers",
    "1127":		"jeers",
    "1128":		"jeers",
    "1129":		"jeers",
    "1130":		"jeers",
    "1131":		"jeers",
    "1151":		"negative",
    "1152":		"negative",
    "1153":		"negative",
    "1154":		"negative",
    "1155":		"negative",
    "1353":		"negative",
    "1151":		"negative",
    "1152":		"negative",
    "1153":		"negative",
    "1154":		"negative",
    "1155":		"negative",
    "1353":		"negative",
    "1156":		"nice_shot",
    "1157":		"nice_shot",
    "1158":		"nice_shot",
    "1345":		"positive",
    "1172":		"positive",
    "1175":		"positive",
    "1174":		"positive",
    "1171":		"positive",
    "1136":		"laugh_long",
    "1137":		"laugh_short",
    "1138":		"laugh_short",
    "1351":		"laugh_short",
    "1352":		"laugh_short",
    "1060":		"battle_cry",
    "1065":		"cheers",
    //Spy
    "708":		"battle_cry",
    "709":		"battle_cry",
    "1309":		"battle_cry",
    "707":		"battle_cry",
    "766":		"jeers",
    "767":		"jeers",
    "768":		"jeers",
    "769":		"jeers",
    "771":		"jeers",
    "770":		"jeers",
    "772":		"laugh_evil",
    "1312":		"laugh_evil",
    "773":		"laugh_happy",
    "774":		"laugh_happy",
    "1313":		"laugh_happy",
    "775":		"laugh_long",
    "1322":		"laugh_short",
    "713":		"cheers",
    "716":		"cheers",
    "809":		"positive",
    "810":		"positive",
    "811":		"positive",
    "710":		"cheers",
    "715":		"cheers",
    "743":		"good_job",
    "812":		"positive",
    "813":		"positive",
    "803":		"pain_severe",
    "804":		"pain_severe",
    "805":		"pain_severe",
    "1387":		"pain_severe",
    "1388":		"pain_severe",
    "704":		"on_fire",
    "705":		"on_fire",
    "706":		"on_fire",
    "806":		"pain_sharp",
    "807":		"pain_sharp",
    "808":		"pain_sharp",
    "1381":		"pain_sharp",
    "1928":		"pain_sharp",
    "709":		"battle_cry",
    "858":		"yes",
    "859":		"yes",
    "3016":		"melee_dare",
    "3023":		"melee_dare",
    "790":		"negative",
    "791":		"negative",
    "740":		"go",
    "741":		"go",
    "742":		"go",
    "746":		"head_left",
    "747":		"head_left",
    "748":		"head_left",
    "749":		"head_right",
    "750":		"head_right",
    "751":		"head_right",
    "752":		"help",
    "753":		"help",
    "754":		"help",
    "779":		"medic",
    "780":		"medic",
    "781":		"medic",
    "782":		"move_up",
    "1317":		"move_up",
    "797":		"no",
    "798":		"no",
    "799":		"no",
    "849":		"thanks",
    "850":		"thanks",
    "1326":		"thanks",
    "857":		"yes",
    "858":		"yes",
    "859":		"yes",
    "783":		"need_dispenser",
    "761":		"incoming",
    "762":		"incoming",
    "763":		"incoming",
    "786":		"need_sentry",
    "708":		"battle_cry",
    "709":		"battle_cry",
    "1309":		"battle_cry",
    "707":		"battle_cry",
    "3016":		"melee_dare",
    "3023":		"melee_dare",
    "710":		"cheers",
    "711":		"cheers",
    "712":		"cheers",
    "713":		"cheers",
    "714":		"cheers",
    "715":		"cheers",
    "716":		"cheers",
    "717":		"cheers",
    "743":		"good_job",
    "744":		"good_job",
    "745":		"good_job",
    "766":		"jeers",
    "767":		"jeers",
    "768":		"jeers",
    "769":		"jeers",
    "771":		"jeers",
    "770":		"jeers",
    "792":		"negative",
    "793":		"negative",
    "790":		"negative",
    "791":		"negative",
    "789":		"negative",
    "1318":		"negative",
    "1319":		"negative",
    "1320":		"negative",
    "1321":		"negative",
    "792":		"negative",
    "793":		"negative",
    "790":		"negative",
    "791":		"negative",
    "789":		"negative",
    "1318":		"negative",
    "1319":		"negative",
    "1320":		"negative",
    "1321":		"negative",
    "794":		"nice_shot",
    "795":		"nice_shot",
    "796":		"nice_shot",
    "809":		"positive",
    "810":		"positive",
    "811":		"positive",
    "812":		"positive",
    "813":		"positive",
    "777":		"laugh_short",
    "778":		"laugh_short",
    "1314":		"laugh_short",
    "1315":		"laugh_short",
    "1316":		"laugh_short",
    "416":		"incoming",
    "417":		"incoming",
    "418":		"incoming",
    "429":		"jeers",
    "431":		"laugh_evil",
    "458":		"pain_critical_death",
    "459":		"pain_critical_death",
    "460":		"pain_critical_death",
    "1282":		"battle_cry",
    "1284":		"cheers",
    "1287":		"go",
    "1291":		"jeers",
    "1293":		"incoming",
    "1294":		"jeers",
    "1303":		"no",
    "1162":		"pain_critical_death",
    "1163":		"pain_critical_death",
    "1164":		"pain_critical_death",
    "1370":		"pain_critical_death",
    "1475":		"incoming",
    "1578":		"pain_critical_death",
    "1579":		"pain_critical_death",
    "1580":		"pain_critical_death",
    "935":		"incoming",
    "936":		"incoming",
    "937":		"incoming",
    "980":		"pain_critical_death",
    "981":		"pain_critical_death",
    "982":		"pain_critical_death",
    "1397":		"pain_critical_death",
    "1398":		"pain_critical_death",
    "294":		"pain_critical_death",
    "295":		"pain_critical_death",
    "296":		"pain_critical_death",
    "32":		"battle_cry",
    "105":		"laugh_short",
    "106":		"laugh_short",
    "130":		"pain_critical_death",
    "131":		"pain_critical_death",
    "132":		"pain_critical_death",
    "1258":		"pain_critical_death",
    "1259":		"pain_critical_death",
    "1260":		"pain_critical_death",
    "1332":		"laugh_evil",
    "1333":		"laugh_evil",
    "1337":		"laugh_short",
    "1338":		"laugh_short",
    "630":		"pain_critical_death",
    "631":		"pain_critical_death",
    "632":		"pain_critical_death",
    "1242":		"pain_critical_death",
    "1697":		"pain_critical_death",
    "1698":		"pain_critical_death",
    "1699":		"pain_critical_death",
    "1839":		"pain_critical_death",
    "764":		"incoming",
    "765":		"incoming",
    "800":		"pain_critical_death",
    "801":		"pain_critical_death",
    "802":		"pain_critical_death",
    "1311":		"incoming",
	"968" : "need_teleporter"
	"117":"need_teleporter"
	"118":"need_teleporter"
	"282":"need_teleporter"
	"618":"need_teleporter"
	"1497":"need_teleporter"
	"446":"need_teleporter"
	"1685":"need_teleporter"
	"1150":"need_teleporter"
	"788": "need_teleporter"


    "taunt_laugh": "laugh_long"
};