local boostMeter = 0;
local hasJumped = 0;
local boostVector = Vector();
local lastAirTS = 0;

AddTimer(0.1, function()
{
    if (!self.IsAlive())
        return;

    local bar = "";
    local i = 10;
    for (; i <= clampCeiling(100, boostMeter); i += 12.5)
        bar += "▰";
    for (; i <= 100; i += 12.5)
        bar += "▱";
    game_text_hop_bar.Display(bar, self);

    if (boostMeter >= 100)
        self.AddCondEx(TF_COND_SPEED_BOOST, 0.3, self);
    self.AddCustomAttribute("move speed bonus",
        1.04 / MERC_MOVESPEED_MULTIPLIER[self.GetPlayerClass()] + boostMeter / 145.0,
        -1);
})

AddTimer(-1, 0, function()
{
    local entIndex = self.entindex();
    if (!GetPropBool(self, "m_Shared.m_bJumping"))
        hasJumped = false;
    else if (!hasJumped)
    {
        hasJumped = true;
        BuildSound("jump").Volume(0.6).Voice().SoundLevel(90).Params({ flags = 1024 }).Play();
    }

    local isMidAir = !self.IsOnGround();
    if (isMidAir)
        lastAirTS = Time();

    local velocity = self.GetAbsVelocity();
    local speed2d = velocity.Length();
    local velZ = abs(velocity.z);
    velocity.z = 0;
    boostVector.z = 0;
    velocity.Norm();
    boostVector.Norm();
    local deltaVector = velocity - boostVector;
    deltaVector.Norm();
    local newForward = boostVector + deltaVector * 0.1;
    newForward.Norm();
    local dot = velocity.Dot(newForward);
    local dot2 = self.EyeAngles().Forward().Dot(newForward);
    boostVector = newForward;

    if ((speed2d < 250 || dot < 0.3 || dot2 < 0.3 || Time() - lastAirTS > 0.2) && velZ < 200)
        boostMeter = clampFloor(0, boostMeter - 1.2);
    else if (isMidAir && speed2d > 310)
        boostMeter = clampCeiling(120, boostMeter + 0.2 + (speed2d - 310) / 520);
});