cosmetics <- {
    hats = [
        ["models/player/items/soldier/bucket.mdl"],
        ["models/player/items/demo/demo_fiesta_sombrero.mdl"],
        ["models/player/items/all_class/saxton_hat_engineer.mdl"],
        ["models/player/items/heavy/football_helmet.mdl", true],
        ["models/player/items/all_class/ghostly_gibus_heavy.mdl"],
        ["models/player/items/soldier/hwn_soldier_hat.mdl"],
        ["models/player/items/demo/crown.mdl"],
        ["models/player/items/heavy/heavy_ushanka.mdl"],
        ["models/player/items/soldier/hat_first_nr.mdl"],
        ["models/player/items/soldier/hat_second_nr.mdl"],
        ["models/player/items/soldier/hat_third_nr.mdl"],
        //["models/player/items/all_class/pyrovision_goggles_soldier.mdl"],
        //["models/player/items/all_class/haunted_eyeball_hat_soldier.mdl"]
    ]
}

local wearableEnts = [];

function ApplyCosmetics()
{
    local seed = playerSeed[self.entindex()];

    foreach (cosmeticType in cosmetics)
    {
        local entry = cosmeticType[seed % cosmeticType.len()];
        local wearable = CreateWorldModel(entry[0]);
        if (entry.len() > 1 && entry[1])
            SetEntityColor(wearable, CalcMercColor());
        wearableEnts.push(wearable);
    }
}

OnSelfEvent("init_custom_character", 5, ApplyCosmetics);

function CalcMercColor()
{
    local steamId = GetPropString(self, "m_szNetworkIDString");
    local indexStr = steamId.len() > 5 ? steamId.slice(5) : playerSeed[self.entindex()];
    local index = indexStr.tointeger();
    return [index % 256, (index >> 8) % 256, (index >> 16) % 256, 255];
}

local playerInTaunt = false;

AddTimer(-1, -10, function()
{
    local inCond = self.InCond(TF_COND_TAUNTING);
    if (inCond && !playerInTaunt)
    {
        playerInTaunt = true;
        foreach (ent in wearableEnts)
            KillIfValid(ent);
        wearableEnts = [];
        ApplyCosmetics();
    }
    else if (!inCond && playerInTaunt)
        playerInTaunt = false;
});

OnSelfEvent("player_death", function() {
    foreach (ent in wearableEnts)
        KillIfValid(ent);
    wearableEnts = [];
})

function DressUpVictoryMerc(propDynamic)
{
    local seed = playerSeed[self.entindex()];

    foreach (cosmeticType in cosmetics)
    {
        local entry = cosmeticType[seed % cosmeticType.len()];
        local wearable = CreateWearableProp(propDynamic, entry[0], null);
        if (entry.len() > 1 && entry[1])
            SetEntityColor(wearable, CalcMercColor());
    }
}