OnSelfEvent("player_death_next", 0, function()
{
    if (hasRoundEnded)
        return;

    local ragdoll = GetPropEntity(self, "m_hRagdoll");
    SetPropBool(ragdoll, "m_bGib", false);
    local ragdollName = ragdoll.GetScriptId();
    SetPropBool(ragdoll, "m_bForcePurgeFixedupStrings", true);
    ragdoll.KeyValueFromString("targetname", ragdollName);
    EntFireByHandle(ragdoll, "Kill", "", 8, ragdoll, ragdoll);
});

OnSelfEvent("player_death_post", 0, function(params)
{
    if (hasRoundEnded)
        return;

    local ragdoll = GetPropEntity(self, "m_hRagdoll");
    SetPropBool(ragdoll, "m_bGib", false);
    local ragdollName = ragdoll.GetScriptId();
    SetPropBool(ragdoll, "m_bForcePurgeFixedupStrings", true);
    ragdoll.KeyValueFromString("targetname", ragdollName);
    EntFireByHandle(ragdoll, "Kill", "", 8, ragdoll, ragdoll);

    local seed = playerSeed[self.entindex()];
    local gibs = [];

    if (params.customkill != TF_DMG_CUSTOM_PLASMA && params.customkill != TF_DMG_CUSTOM_PLASMA_CHARGED)
    {
        local wearable = CreateWearableProp(ragdoll, "models/gungame/player/mercenary_ragdoll.mdl", ragdollName);
        SetEntityColor(wearable, CalcMercColor());
        EntFireByHandle(wearable, "Kill", "", 8, ragdoll, ragdoll);
    }

    foreach (cosmeticType in cosmetics)
    {
        local entry = cosmeticType[seed % cosmeticType.len()];
        /*if (entry.len() > 2 && entry[2])
        {
            gibs.push(entry[0]);
            //local wearable = CreateWearableProp(ragdoll, entry[0]);
            //if (entry.len() > 1 && entry[1])
            //    SetEntityColor(wearable, CalcMercColor());
            //EntFireByHandle(wearable, "Kill", "", 8, ragdoll, ragdoll);
        }
        else*/
            gibs.push(entry[0]);
    }
    ShootGibs(gibs, self.EyePosition() + Vector(0, 0, 65), self.GetAbsAngles())
});

function CreateWearableProp(ragdoll, modelName, ragdollName)
{
    local propModel = SpawnEntityFromTable("prop_dynamic", {
        model = modelName
        disableshadows = 1,
        disablereceiveshadows = 1,
        solid = 0,
        DisableBoneFollowers = 1,
        origin = self.GetOrigin()
        LightingOrigin = ragdollName
    });
    propModel.SetSolid(0);
    propModel.SetMoveType(0, 0);
    SetPropInt(propModel, "m_fEffects", 129);
    SetPropInt(propModel, "m_nNextThinkTick", 0x7FFFFFFF);
    SetPropBool(propModel, "m_bForcePurgeFixedupStrings", true);
    EntFireByHandle(propModel, "SetParent", "!activator", -1, ragdoll, ragdoll);
	return propModel;
}

function ShootGibs(gibs, origin, angles)
{
    local gibSpawner = SpawnEntityFromTable("env_shooter",
    {
        spawnflags = 5,
        m_iGibs = 1,
        m_flVelocity = 440,
        scale = 1,
        m_flVariance = 0,
        m_flGibLife = 8,
        shootsounds = 3,
        simulation = 1,
        nogibshadows = true
        origin = origin
        angles = angles
    });
    SetPropBool(gibSpawner, "m_bForcePurgeFixedupStrings", true);
    for (local i = 0; i < gibs.len(); i++)
    {
        EntFireByHandle(gibSpawner, "AddOutput", "shootmodel " + gibs[i], i * 0.02, null, null);
        EntFireByHandle(gibSpawner, "Shoot", "", i * 0.02, null, null);
    }
    EntFireByHandle(gibSpawner, "Kill", "", 3, null, null);
}