IncludeScript("gungame/gungame/weapon_list.nut");
IncludeScript("gungame/gungame/weapon_order.nut");

::gunGameProgress <- player_collection(0);
::fragLimit <- GUNGAME_WEAPON_POOLS.len() - 1;
::MERC_SCRIPT <- "gungame/gungame/gg_mercenary.nut";

OnGameEvent("player_death_post", 20, function(victim, params)
{
    RunWithDelay(0.001, function() //todo fix?
    {
        local attacker = GetPlayerFromParams(params, "attacker");
        local assister = GetPlayerFromParams(params, "assister");

        if (attacker && attacker != victim)
        {
            local weaponTT = GetCurrentGunGameWeapon(attacker);
            if (params.weapon == "shovel" || weaponTT != GetWeaponTypeByName("golden_crowbar")) //todo hardcode
                SwitchToNextWeapon(attacker);
        }
        if (assister && assister != victim)
        {
            local weaponTT = GetCurrentGunGameWeapon(assister);
            if (weaponTT != GetWeaponTypeByName("golden_crowbar")) //todo hardcode
            {
                BuildSound("assist_sfx").Scope(assister).Entity(assister).SinglePlayer().Play();
                SwitchToNextWeapon(assister);
            }
        }
    });
});

OnGameEvent("player_death_post", 0, function(player, params)
{
    local attacker = GetPlayerFromParams(params, "attacker");
    if (attacker && attacker != player)
    {
        local particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red_shower",
            origin = attacker.GetCenter(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        SetPropBool(particle, "m_bForcePurgeFixedupStrings", true);
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1.05, null, null);

        particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red",
            origin = attacker.GetOrigin(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        SetPropBool(particle, "m_bForcePurgeFixedupStrings", true);
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1.05, null, null);

        AddTimer(0.1, 0, function() {
            if (IsValidPlayer(attacker))
                attacker.SetHealth(clampCeiling(attacker.GetHealth() + 5, attacker.GetMaxHealth()));
        }, particle);
    }
});

function SwitchToNextWeapon(player)
{
    if (hasRoundEnded)
        return;
    local progress = gunGameProgress[player.entindex()]++;
    if (progress >= fragLimit - 1)
    {
        EndRound(player);
        return;
    }

    player.SetScriptOverlayMaterial("gungame/ui/" + GetCurrentGunGameWeapon(player).name + "_to_" + GetNextGunGameWeapon(player).name);

    if ("SwitchToNextWeapon" in player.GetScriptScope())
    {
        //todo hardcode
        local isScoped = player.InCond(TF_COND_AIMING) && player.GetActiveWeapon() && player.GetActiveWeapon().GetClassname() == "tf_weapon_sniperrifle";
        RunWithDelay(isScoped ? 1 : -1, function() {
            player.RemoveCond(TF_COND_AIMING);
            SwitchToNextWeapon();
        }, player)
    }
}

::GetScores <- function()
{
    return gunGameProgress;
}

::GetScore <- function(player)
{
    return gunGameProgress[player.entindex()];
}

::GetScoreByIndex <- function(entIndex)
{
    return gunGameProgress[entIndex];
}