IncludeScript("ffa/mercenary/_mercenary.nut");

function AssembleArsenal(keepCurrentHP = true)
{
    local gungameWeapon = EquipWeapon(GetCurrentGunGameWeapon(self));

    if (gungameWeapon.GetSlot() != 2)
    {
        self.Weapon_Switch(EquipWeapon(GetWeaponTypeByName("crowbar")));
        OnTickEnd(function() {
            self.Weapon_Switch(gungameWeapon);
            RefreshCharacter(keepCurrentHP);
        });
    }
    else
    {
        local switch_fix = EquipWeapon(GetWeaponTypeByName("switch_fix"));
        self.Weapon_Switch(switch_fix);
        SetPropBool(switch_fix, "m_bForcePurgeFixedupStrings", true);
        switch_fix.Kill();
        RunWithDelay(0.1, function()
        {
            self.Weapon_Switch(gungameWeapon);
            RefreshCharacter(keepCurrentHP);
        });
    }
}

OnSelfEvent("init_custom_character", 10, function()
{
    EntFireByHandle(env_screenoverlay, "StartOverlays", "", -1, null, null);
    self.SetScriptOverlayMaterial("gungame/ui/" + GetCurrentGunGameWeapon(self).name + "_to_" + GetNextGunGameWeapon(self).name);
});

function SwitchToNextWeapon()
{
    for (local i = 0; i < 10; i++)
    {
        local weaponEnt = GetPropEntityArray(self, "m_hMyWeapons", i);
        KillIfValid(weaponEnt);
        SetPropEntityArray(self, "m_hMyWeapons", null, i);
    }
    if (self.InCond(TF_COND_AIMING))
        AssembleArsenal();
    else
    {
        self.RemoveCond(TF_COND_AIMING);
        RunWithDelay(0.01, AssembleArsenal)
    }
}