::WEAPON_TYPES <- [
    {
        name = "crowbar",
        baseclass = "tf_weapon_shovel",
        baseid = 196,
        viewmodel = "models/dmgg/weapons/crowbar/v_crowbar.mdl",
        worldmodel = "models/dmgg/weapons/crowbar/v_crowbar.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("fire rate bonus HIDDEN", 0.5, -1);
            weaponEnt.AddAttribute("damage penalty", 0.55, -1);
            weaponEnt.AddAttribute("mod crit while airborne", 1, -1);
            weaponEnt.AddAttribute("crit kill will gib", 1, -1);
            weaponEnt.AddAttribute("melee range multiplier", 1.15, -1);
            weaponEnt.AddAttribute("melee bounds multiplier", 1.1, -1);
        }
    },
    {
        name = "golden_crowbar",
        baseclass = "tf_weapon_shovel",
        baseid = 196,
        viewmodel = "models/dmgg/weapons/crowbar/v_crowbar_golden.mdl",
        worldmodel = "models/dmgg/weapons/crowbar/w_crowbar_golden.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        OnEquip = function(player, weaponTT, weaponEnt) {
            player.KeyValueFromString("targetname", "player"+player.entindex());
            local mercColor = player.GetScriptScope().CalcMercColor();
            RunWithDelay(0.1, function(weaponEnt) {
                GetPropEntity(self, "m_hViewModel").DisableDraw();
                weaponEnt.DisableDraw();
            }, weaponEnt, player)
            SetPropBool(SpawnEntityFromTable("tf_glow", {
                target = "player"+player.entindex()
                StartDisabled = 0
                GlowColor = mercColor[0]+" "+mercColor[1]+" "+mercColor[2]+" 255"
            }), "m_bForcePurgeFixedupStrings", true);
            weaponEnt.AddAttribute("fire rate bonus HIDDEN", 0.5, -1);
            weaponEnt.AddAttribute("damage penalty", 0.55, -1);
            weaponEnt.AddAttribute("turn to gold", 1, -1);
            weaponEnt.AddAttribute("melee range multiplier", 1.25, -1);
            weaponEnt.AddAttribute("melee bounds multiplier", 1.25, -1);
        }
    },
    {
        name = "switch_fix",
        baseclass = "tf_weapon_pistol",
        viewmodel = "models/empty.mdl",
        worldmodel = "models/empty.mdl",
        baseid = 23,
    },
    {
        name = "loser",
        baseclass = "tf_weapon_shovel",
        viewmodel = "models/empty.mdl",
        worldmodel = "models/empty.mdl",
        playermodel = "models/gungame/player/mercenary_loser.mdl"
        baseid = 196,
    },
    {
        name = "victory",
        baseclass = "tf_weapon_shovel",
        baseid = 196,
    },
    {
        name = "pistol",
        baseclass = "tf_weapon_pistol",
        baseid = 22,
        playerclass = TF_CLASS_ENGINEER
        viewmodel = "models/dmgg/weapons/merc_arms/merc_engineer_arms.mdl",
        playermodel = "models/gungame/player/mercenary_scattergun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 200, 2);
        }
    },
    {
        name = "revolver",
        baseclass = "tf_weapon_revolver",
        playerclass = TF_CLASS_SPY
        baseid = 24,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_spy_arms.mdl",
        playermodel = "models/gungame/player/mercenary_revolver.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
            SetPropIntArray(player, "m_iAmmo", 32, 0);
            SetPropIntArray(player, "m_iAmmo", 32, 2);
        }
    },
    {
        name = "enforcer",
        baseclass = "tf_weapon_revolver",
        playerclass = TF_CLASS_SPY
        baseid = 460,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_spy_arms.mdl",
        playermodel = "models/gungame/player/mercenary_revolver.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 0);
            SetPropIntArray(player, "m_iAmmo", 32, 1);
            SetPropIntArray(player, "m_iAmmo", 32, 2);
        }
    },
    {
        name = "ambassador",
        baseclass = "tf_weapon_revolver",
        playerclass = TF_CLASS_SPY
        baseid = 61,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_spy_arms.mdl",
        playermodel = "models/gungame/player/mercenary_revolver.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        name = "shortstop",
        baseclass = "tf_weapon_handgun_scout_primary",
        playerclass = TF_CLASS_SCOUT
        baseid = 220,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/gungame/player/mercenary_scattergun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        name = "force_a_nature",
        baseclass = "tf_weapon_scattergun",
        playerclass = TF_CLASS_SCOUT
        viewmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/gungame/player/mercenary_revolver.mdl"
        baseid = 45,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(2);
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        name = "soda_popper",
        baseclass = "tf_weapon_soda_popper",
        playerclass = TF_CLASS_SCOUT
        viewmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/gungame/player/mercenary_revolver.mdl"
        baseid = 448,
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.SetClip1(2);
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        name = "loch_n_load",
        baseclass = "tf_weapon_grenadelauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 308,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/gungame/player/mercenary_grenade.mdl"
    },
    {
        name = "panic_attack",
        baseclass = "tf_weapon_shotgun_soldier",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl"
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 1153
    },
    {
        name = "shotgun",
        baseclass = "tf_weapon_shotgun_soldier",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl"
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 199
    },
    {
        name = "frontier_justice",
        baseclass = "tf_weapon_shotgun_soldier",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl"
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 141
    },
    {
        name = "family_business",
        baseclass = "tf_weapon_shotgun_hwg",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_heavy_arms.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_HEAVY
        baseid = 425,
    },
    {
        name = "smg",
        baseclass = "tf_weapon_smg",
        playerclass = TF_CLASS_SNIPER
        baseid = 16,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl"
        playermodel = "models/gungame/player/mercenary_sniper.mdl"
    },
    {
        name = "syringe_gun",
        baseclass = "tf_weapon_syringegun_medic",
        playerclass = TF_CLASS_MEDIC
        baseid = 17,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_medic_arms.mdl",
        playermodel = "models/gungame/player/mercenary_scattergun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 150, 1);
        }
    },
    {
        name = "blutsauger",
        baseclass = "tf_weapon_syringegun_medic",
        playerclass = TF_CLASS_MEDIC
        baseid = 36,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_medic_arms.mdl",
        playermodel = "models/gungame/player/mercenary_scattergun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 150, 1);
        }
    },
    {
        name = "rocket_launcher",
        baseclass = "tf_weapon_rocketlauncher",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 18
    },
    {
        name = "cow_mangler",
        baseclass = "tf_weapon_particle_cannon",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 441
    },
    {
        name = "original",
        baseclass = "tf_weapon_rocketlauncher",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 513
    },
    {
        name = "liberty_launcher",
        baseclass = "tf_weapon_rocketlauncher",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 414
    },
    {
        name = "black_box",
        baseclass = "tf_weapon_rocketlauncher",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 228
    },
    {
        name = "airstrike",
        baseclass = "tf_weapon_rocketlauncher_airstrike",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 1104
    },
    {
        name = "grenade_launcher",
        baseclass = "tf_weapon_grenadelauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 19,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/gungame/player/mercenary_grenade.mdl"
    },
    {
        name = "iron_bomber",
        baseclass = "tf_weapon_grenadelauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 1151,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/gungame/player/mercenary_grenade.mdl"
    },
    {
        name = "sticky_launcher",
        baseclass = "tf_weapon_pipebomblauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 20,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl",
        playermodel = "models/gungame/player/mercenary_grenade.mdl"
    },
    {
        name = "quickie_launcher",
        baseclass = "tf_weapon_pipebomblauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 1150,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/gungame/player/mercenary_grenade.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("stickies detonate stickies", 0, -1);
        }
    },
    {
        name = "direct_hit",
        baseclass = "tf_weapon_rocketlauncher_directhit",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 127
    },
    {
        name = "beggars_bazooka",
        baseclass = "tf_weapon_rocketlauncher",
        viewmodel = "models/dmgg/weapons/merc_arms/merc_soldier_arms.mdl",
        playermodel = "models/gungame/player/mercenary_rocket.mdl"
        playerclass = TF_CLASS_SOLDIER
        baseid = 730
    },
    {
        name = "scattergun",
        baseclass = "tf_weapon_scattergun",
        playerclass = TF_CLASS_SCOUT
        baseid = 13,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/gungame/player/mercenary_scattergun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        name = "back_scatter",
        baseclass = "tf_weapon_scattergun",
        playerclass = TF_CLASS_SCOUT
        baseid = 1103,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/gungame/player/mercenary_scattergun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        name = "baby_faces_blaster",
        baseclass = "tf_weapon_pep_brawler_blaster",
        playerclass = TF_CLASS_SCOUT
        baseid = 772,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_scout_arms.mdl",
        playermodel = "models/gungame/player/mercenary_scattergun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        name = "sniper_rifle",
        baseclass = "tf_weapon_sniperrifle",
        playerclass = TF_CLASS_SNIPER
        baseid = 14,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl",
        playermodel = "models/gungame/player/mercenary_sniper.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
        }
    },
    {
        name = "awper_hand",
        baseclass = "tf_weapon_sniperrifle",
        playerclass = TF_CLASS_SNIPER
        baseid = 851,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_sniper_arms.mdl",
        playermodel = "models/gungame/player/mercenary_sniper.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
        }
    },
    {
        name = "rescue_ranger",
        baseclass = "tf_weapon_shotgun_building_rescue",
        playerclass = TF_CLASS_ENGINEER
        baseid = 997,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_engineer_arms.mdl",
        playermodel = "models/gungame/player/mercenary_scattergun.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 32, 1);
        }
    },
    {
        name = "loose_cannon",
        baseclass = "tf_weapon_cannon",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 996,
        viewmodel = "models/dmgg/weapons/merc_arms/merc_demo_arms.mdl"
        playermodel = "models/gungame/player/mercenary_grenade.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("blast dmg to self increased", 0.4, -1);
        }
    }
];

RunWithDelay(0.01, function()
{
    local model;
    foreach (weaponType in WEAPON_TYPES)
    {
        if (model = safeget(weaponType, "viewmodel", null))
            PrecacheModel(model);
        if (model = safeget(weaponType, "worldmodel", null))
            PrecacheModel(model);
        if (model = safeget(weaponType, "playermodel", null))
            PrecacheModel(model);
    }
});